tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_BaronGeddon_Inferno_OnLoad");

CT_RABoss_BaronGeddon_ShouldLoop = false;

function CT_RABoss_BaronGeddon_Inferno_OnLoad()
	local s = string.gsub(UNITDIESOTHER, "%%s", "%(.+%)");
	CT_RABoss_Sarf_UnitDiesOther = s;

	CT_RABoss_AddEvent("Baron Geddon", "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS", CT_RABoss_BaronGeddon_EventHandler_Inferno);
	CT_RABoss_AddEvent("Baron Geddon", "CHAT_MSG_COMBAT_HOSTILE_DEATH", CT_RABoss_BaronGeddon_EventHandler_Inferno);
	CT_RABoss_AddDropDownButton("Baron Geddon", { CT_RABOSS_BARON_ALERT_INFERNO, CT_RABOSS_BARON_ALERT_INFERNO_INFO }, "CT_RABoss_ModInfo", "alertInferno", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton("Baron Geddon", { CT_RABOSS_BARON_ANNOUNCE_INFERNO, CT_RABOSS_BARON_ANNOUNCE_INFERNO_INFO }, "CT_RABoss_ModInfo", "announceInferno", "CT_RABoss_SetInfo");
	CT_RABoss_SetVar("Baron Geddon", "alertInferno", true);
end

function CT_RABoss_BaronGeddon_EventHandler_Inferno(event)
	local baronOptions = CT_RABoss_Mods["Baron Geddon"];
	if ( not baronOptions or not baronOptions["status"] or not baronOptions.enabled ) then
		return;
	end
	if ( event == "PLAYER_TARGET_CHANGED" ) then
		if ( UnitName("target") == CT_RABOSS_BARON_NAME ) and ( UnitIsCorpse("target") ) then
			CT_RABoss_UnSchedule("CT_RABoss_BaronGeddon_EventHandler_Inferno");
		end
		return;
	elseif ( event == "CHAT_MSG_COMBAT_HOSTILE_DEATH" ) then
		for name in string.gfind(arg1, CT_RABoss_Sarf_UnitDiesOther) do
			if ( name == CT_RABOSS_BARON_NAME ) then
				CT_RABoss_UnSchedule("CT_RABoss_BaronGeddon_EventHandler_Inferno");
			end
		end
		return;
	elseif ( event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS" ) 
		and ( string.find(arg1, CT_RABOSS_BARON_INFERNO) ) 
		and ( not baronOptions["Inferno"] ) then
		
		if ( baronOptions["alertInferno"] ) or ( baronOptions["announceInferno"] ) then
			baronOptions["Inferno"] = true;
			CT_RABoss_Announce(CT_RABOSS_BARON_DOINGINFERNO, baronOptions["announceInferno"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Schedule("CT_RABoss_BaronGeddon_EventHandler_Inferno", 20, "preInfernoWarning");
		end
			
	elseif ( event == "preInfernoWarning" ) then
		if ( baronOptions["alertInferno"] ) or ( baronOptions["announceInferno"] ) then
			baronOptions["Inferno"] = false;
			CT_RABoss_Announce(CT_RABOSS_BARON_5SECSINFERNO, baronOptions["announceInferno"]);
			CT_RABoss_PlaySound(3);
			
			if ( CT_RABoss_BaronGeddon_ShouldLoop ) then
				CT_RABoss_Schedule("CT_RABoss_BaronGeddon_EventHandler_Inferno", 25, "preInfernoWarning");
			end
		end
	end
end
